Subject: Re: [sipcore] [dispatch] Comments on draft-allen-dispatch-routing-out-of-dialog-request-00

From: [email-masked] (Dale R. Worley)
Date: Thu, 3 Apr 2014 17:19:56 -0400

> From: Hadriel Kaplan <[email-masked]>
>
> On Mar 21, 2014, at 3:31 PM, Dale R. Worley <[email-masked]> wrote:
> > I'm curious what you mean by "just behave like they're normal contact
> > URIs".  My understanding is that the contact URI is used for whatever
> > it's used for *because* it's the contact URI.  If it's marked as a
> > GRUU, that presumably is a hint that your odds of success are higher,
> > but what would you do differently?
> 
> You would send out-of-dialog REFERs, and you could (in theory) store
> the GRUU for future use indefinitely, such as in an address book.

When you say "You would send out-of-dialog REFERs", it sounds like
this is the *bulk* of the problems you're encountering.  So let me
ask, "If no UA ever sent out-of-dialog REFERs, would the problems you
see with GRUUs vanish?"

Obviously, one shouldn't retain GRUUs indefinitely, since they're not
addresses of record, and they're intrinsically bound to specific
contact addresses, which are expected to change.  In a perfect world,
3261 would be updated so that the From/To URI provided by the far end
would always be its AoR, so that the near end could store it properly.
(Whereas now, the destination's From/To URI is fixed by the
originator.  IIRC, there is a proposal out there to change this, but
there has been nervousness about whether it is upward-compatible with
current systems.)

> [A global contact is] just a Contact URI that encodes information in
> itself such that it's uniquely related to the original Contact for
> the original dialog.

This sounds like what I've been calling a "contact alias".

> The userinfo portion has sufficient information for the SBC to
> figure out which original Contact URI to use as a target for an
> out-of-dialog request (or to match to some internal dialog state).

Of course, the additional information could be put into a URI
parameter instead of the userinfo.

Dale

---

From: Hadriel Kaplan <[email-masked]>
Date: Fri, 11 Apr 2014 16:50:23 -0400

> ask, "If no UA ever sent out-of-dialog REFERs, would the problems you

I don't know.  REFER is the main one for out-of-dialog messages to a previously received in-dialog Contact that I see.

I seem to recall some problems with out-of-dialog Subscriptions[1] to in-dialog Contacts too, but that was a long time ago and not GRUU-specific.

[1] I can't remember what it was a Subscription for - dialog-event package maybe? Or maybe KPML?

> parameter instead of the user info.

Sure, though I think putting it in userinfo is more likely to work every time.

-hadriel